$(document).ready(function() {
   if ($(window).width() >= 1280) {
       $('.learning-content #CourseContent').addClass('active');
       $('.learning-content .body-content').addClass('shorten');
   }
});


//resume course button
$(document).on('click', '.learning-overview .resume-btn', function() {
   $('.learning-overview').css('display', 'none');
   $('#lesson-id').css('display', 'flex');
});

// Reveal course contents on click or keyboard activation (Enter/Space)
$(document).on('click keydown', '.course-contents-reveal', function(event) {
   // Check if the event is a keydown and if the key pressed is not Enter (13) or Space (32)
   if (event.type === 'keydown' && event.keyCode !== 13 && event.keyCode !== 32) {
      return;
   }

   // Toggle the .active class on #CourseContent
   $('.learning-content #CourseContent').toggleClass('active');
   $('.learning-content .body-content').toggleClass('shorten');

   // Check if the device width is less than 1280px
   if ($(window).width() < 1280) {
      // Toggle the .course-contents-overlay class on .overlay and .fixed class on <html>
      $('.course-contents-overlay').toggleClass('active');
      $('html').toggleClass('fixed');
   } else {
      // If width is >= 1280px and .learning-overview is not an ancestor of .course-contents-reveal, hide the button
      if (!$(this).closest('.learning-overview').length) {
         // Hide the .course-contents-reveal button if not a descendant of .learning-overview
         $(this).hide();
      }
   }
});





// Click outside of #CourseContent (on the overlay) to remove classes
$(document).on('click', '.overlay', function(e) {
   // Check if the device width is less than 1280px
   if ($(window).width() < 1280) {
      // Check if the click is outside #CourseContent
      if (!$(e.target).closest('#CourseContent').length) {
         $('.learning-content #CourseContent').removeClass('active');
         $('.course-contents-overlay').removeClass('active');
         $('html').removeClass('fixed');
         $('.learning-content .body-content').removeClass('shorten')
      }
   }
});

// Close button handling with click and keyboard activation
$(document).on('click keydown', '.close-course-contents', function(e) {
   // Check if it's a click event or a keyboard event (Enter or Space key)
   if (e.type === 'click' || (e.type === 'keydown' && (e.key === 'Enter' || e.key === ' '))) {
       // Prevent default behaviour for the Space key
       if (e.key === ' ') {
           e.preventDefault();
       }

       // Check if the device width is less than 1280px
       if ($(window).width() < 1280) {
          // Remove the .active and .course-contents-overlay classes from #CourseContent and .overlay, and .fixed class from <html>
          $('.learning-content #CourseContent').removeClass('active');
          $('.course-contents-overlay, .overlay').removeClass('active');
          $('html').removeClass('fixed');
          $('.learning-content .body-content').removeClass('shorten')
       } else {
          // If width is >= 1280px, remove the .active class from #CourseContent and set .course-contents-reveal to display flex
          $('.learning-content #CourseContent').removeClass('active');
          $('.course-contents-reveal').css('display', 'flex');
          $('.learning-content .body-content').removeClass('shorten')
       }
   }
});


// Handle Escape key press to close the content
$(document).on('keydown', function(e) {
   if (e.key === 'Escape') {
      // Check if the device width is less than 1280px
      if ($(window).width() < 1280) {
         // Remove the .active and .course-contents-overlay classes from #CourseContent and .overlay, and .fixed class from <html>
         $('.learning-content #CourseContent').removeClass('active');
         $('.course-contents-overlay').removeClass('active');
         $('html').removeClass('fixed');
      } else {
         // If width is >= 1280px, only remove the .active class from #CourseContent
         $('.learning-content #CourseContent').removeClass('active');
      }
   }
});





//smooth anchor link scrolling
$(document).ready(function () {
   $('a[href^="#"]').on('click', function (event) {
      event.preventDefault();

      var target = $(this).attr('href');
      $('html, body').animate({
         scrollTop: $(target).offset().top
      }, 800); // Adjust the duration (800ms) as needed
   });
});

//active class on active jump link
$(document).ready(function () {
   var $links = $('.anchor-link');
   var ignoreOnLargeScreens = '#CourseContent';

   $(window).on('scroll', function () {
      var scrollPos = $(window).scrollTop();
      var windowWidth = $(window).width();

      $links.each(function () {
         var target = $(this).attr('href');

         // Skip #CourseContent on devices 1280px and above
         if (windowWidth >= 1280 && target === ignoreOnLargeScreens) {
            return;
         }

         var $section = $(target);

         if ($section.position().top <= scrollPos && ($section.position().top + $section.outerHeight()) > scrollPos) {
            $links.removeClass('active');
            $(this).addClass('active');
         }
      });
   });

   // Smooth scrolling for anchor links
   $links.on('click', function (event) {
      event.preventDefault();

      var target = $(this).attr('href');
      $('html, body').animate({
         scrollTop: $(target).offset().top
      }, 800); // Adjust the duration as needed
   });
});


//avatar initials
$(document).ready(function() {
   $('.person').each(function() {
       // Find the h3 element containing the author's name
       var authorName = $(this).find('.person-details-container a h3').text().trim();
       
       // Remove 'Dr.' if present
       authorName = authorName.replace(/^Dr\.\s*/i, '');

       // Split the name to get the initials
       var initials = authorName.split(' ').map(function(namePart) {
           return namePart.charAt(0).toUpperCase();
       }).join('');

       // Insert the initials into the .author-avatar div
       $(this).find('.person-avatar').text(initials);
   });
});

//avatar colour
$(document).ready(function () {
   $('.person').each(function () {
       // Get the author's name from the .person-details-container a h3 element
       var authorName = $(this).find('.person-details-container a h3').text().trim();

       // Split the author's name into words
       var nameParts = authorName.split(" ");
       var lastName = nameParts[nameParts.length - 1];

       // Get the first letter of the last name and convert it to uppercase
       var firstLetterLastName = lastName.charAt(0).toUpperCase();

       // Define the class based on the first letter of the last name
       var assignedClass = '';
       if ('0ABC'.includes(firstLetterLastName)) {
           assignedClass = 'dark-blue';
       } else if ('1DEF'.includes(firstLetterLastName)) {
           assignedClass = 'light-blue';
       } else if ('2GHI'.includes(firstLetterLastName)) {
           assignedClass = 'purple';
       } else if ('3JKL'.includes(firstLetterLastName)) {
           assignedClass = 'red';
       } else if ('4MNO'.includes(firstLetterLastName)) {
           assignedClass = 'peach';
       } else if ('5PQR'.includes(firstLetterLastName)) {
           assignedClass = 'orange';
       } else if ('6ST'.includes(firstLetterLastName)) {
           assignedClass = 'yellow';
       } else if ('7UV'.includes(firstLetterLastName)) {
           assignedClass = 'green';
       } else if ('8WX'.includes(firstLetterLastName)) {
           assignedClass = 'aqua';
       } else if ('9YZ'.includes(firstLetterLastName)) {
           assignedClass = 'mint';
       }

       // Assign the class to the .site_messagebox_message_container element
       $(this).addClass(assignedClass);
   });
});

//order of mark as complete button
$(document).ready(function() {
   function rearrangeNavigation() {
       if ($(window).width() < 640) {
           $('.mark-learning-complete, .mark-learning-incomplete').insertBefore('.prev-learning');
       } else {
           // Optional: move them back to the original position on larger screens
           $('.mark-learning-complete').insertAfter('.prev-learning');
           $('.mark-learning-incomplete').insertAfter('.mark-learning-complete');
       }
   }

   // Call the function on page load
   rearrangeNavigation();

   // Call the function on window resize
   $(window).resize(function() {
       rearrangeNavigation();
   });
});


//Reorder video on mobile for Overview
$(document).ready(function() {
   function moveVideoWrapper() {
       if ($(window).width() < 1024) {
           $('.learning-overview .course-preview-video-wrapper').insertBefore('.learning-overview .heading-content');
           $('.learning-overview .course-contents-reveal').insertBefore('.learning-overview .course-preview-video-wrapper');
       }
   }

   // Run on initial load
   moveVideoWrapper();

   // Run on window resize
   $(window).resize(function() {
       moveVideoWrapper();
   });
});


/*$(document).ready(function() {
   function adjustLayout() {
       var $courseContentsReveal = $('.learning-overview .course-contents-reveal');
       var $resumeBtn = $('.learning-overview .heading .resume-btn');
       var $favoriteBtn = $('.learning-overview .heading .favorite-btn');
       var $coursePreviewWrapper = $('.learning-overview .course-preview-video-wrapper');

       // Clear existing order before rearranging
       $courseContentsReveal.insertBefore($coursePreviewWrapper);

       if ($(window).width() >= 1024) {
           // Place the buttons in the specified order
           $courseContentsReveal.insertAfter($resumeBtn);
           $favoriteBtn.insertAfter($courseContentsReveal);
       } else {
           // Adjust button order for smaller screens
           if ($(window).width() < 500) {
               $favoriteBtn.insertBefore($resumeBtn);
           } else {
               $favoriteBtn.insertAfter($resumeBtn);
           }
       }
   }

   // Initial check
   adjustLayout();

   // Adjust on window resize
   $(window).resize(adjustLayout);
});

*/

function openLesson(learning, learningName) {
   // Hide all elements with class "body-content"
   $(".body-content").hide();
 
   // Remove the "active" class from all elements with class "tablinks"
   $(".learning-item").removeClass("active");
 
   // Show the current tab and add the "active" class to the clicked button
   $("#" + learningName).show();
   $(learning.currentTarget).addClass("active");
 }
 
// Get the element with id="defaultOpen"
var defaultOpen = $("#defaultOpen");

// Call openLesson with the defaultOpen element and the corresponding city name
openLesson({ currentTarget: defaultOpen }, "lesson-overview"); // Replace "defaultlearningName" with the actual ID of the default city content